<!DOCTYPE html>
<html><head><meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task60.60</title>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css" integrity="sha512-SzlrxWUlpfuzQ+pcUCosxcglQRNAq/DZjVsC0lE40xsADsfeQoEypE+enwcOiGjk/bSuGGKHEyjSoQ1zVisanQ==" crossorigin="anonymous" referrerpolicy="no-referrer" />

</head>

<body>
  <div class="container">
    <h2>Responsive Form</h2>
    <p>Car - Car Type select</p>

    <form id="inputform01" class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="fname">First Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="fname" name="firstname" placeholder="Your name.." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="lname">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="lname" name="lastname" placeholder="Your last name.." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="car">Car</label>
        </div>
        <div class="col-sm-3">
          <select id="car-select" name="car" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="type">type</label>
        </div>
        <div class="col-sm-3">
          <select id="type-select" disabled="" name="type" class="form-control">
          </select>
        </div>
      </div>
      <div class="row pull-right">
        <div class="col-sm-12">
          <input type="button" value="Send" class="btn btn-info" id="send-button">
        </div>
      </div>
    </form>
  </div>
  <script>
    //Get data car
    $.ajax({
      url: "http://localhost:8080/cars",
      method: "GET",
      success: function(pObjRes) {
        console.log(pObjRes);
        loadDataToCarSelect(pObjRes);
      },
      error: function(paramErr) {
        console.log(paramErr.responseText);
      }
    });

    var gCarSelectElement = $("#car-select");

    function loadDataToCarSelect(pCarList) {
      for (i = 0; i < pCarList.length; i++) {
        var bCarOption = $("<option/>");
        bCarOption.prop("value", pCarList[i].carCode);
        bCarOption.prop("text", pCarList[i].carName);
        gCarSelectElement.append(bCarOption);
      };
    }

    var gTypeSelectElement = $("#type-select");

    //callback function
    gCarSelectElement.on("change", function () {
      gTypeSelectElement.html("");
      var bCarCode = $(this).val();

      getTypesByCarCode(bCarCode);
    });

    //find brandTypes array by brandId
    function getTypesByCarCode(pCarCode) {
      $.ajax({
        url: "http://localhost:8080/cartype-query?carCode=" + pCarCode,
        method: "GET",
        success: function(pObjRes) {
          console.log(pObjRes);
          loadDataToTypeSelect(pObjRes);
        },
        error: function(paramErr) {
          console.log(paramErr.responseText);
        }
      });
    }

    function loadDataToTypeSelect(pTypeList) {
      if (pTypeList.length > 0) {
        gTypeSelectElement.prop("disabled", false);

        for (i = 0; i < pTypeList.length; i++) {
          var bTypeOption = $("<option/>");
          bTypeOption.prop("value", pTypeList[i].typeCode);
          bTypeOption.prop("text", pTypeList[i].typeName);
          gTypeSelectElement.append(bTypeOption);
        };
      } else {
        gTypeSelectElement.prop("disabled", "disabled");
      }
    }

  </script>


</body></html>